> For the complete documentation index, see [llms.txt](https://docs.fractalworks.io/joule/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.fractalworks.io/joule/use-case-examples/telco/geospatial-marketing.md).

# Geospatial marketing

***

This example simulates geospatial real-time marketing through the use of geofence triggers and custom messages. Geofences are automatically added to the processor through the use of auto reference data binding.

## Use case configuration

*File: app-geospatialMarketingCampaign.env*

```bash
SOURCEFILE=conf/sources/mobileSimulatedStream.yaml
REFERENCEDATA=conf/sources/mobileReferenceData.yaml
ENGINEFILE=conf/usecases/analytics/mobileEventDynamicCampaignStream.yaml
PUBLISHFILE=conf/publishers/marketingCampaignFile.yaml
```

Reference data stores can be used to prime the geofences. Change the required yaml file to test this feature in the app.env file.

```bash
ENGINEFILE=conf/usecases/analytics/mobileEventDynamicCampaignUsingGeofenceDataStoreStream.yaml
```

## Pipeline **configuration**

{% code overflow="wrap" %}

```yaml
processing unit:
  pipeline:
    - filter:
        expression: "(imsi !== null ) ? true : false;"
    
    - entity geo tracker:
        name: TFLMessage
        entity key: imsi
        min dwelling time: 2
        timeUnit: SECONDS  
        default radius: 150.0f
        geofences:
          stores:
            geoFenceStore:
              storeName: londonTransportStations
              getInitialImage: true
              initialImageQuery: select * from londonTransportStations
              primaryKey: id
        
    - geofence occupancy trigger:
        name: marketingCampaign
        tracker field: geoTrackingInfo
        plugin: com.fractalworks.streams.examples.telco.marketing.MarketingCampaignMessenger
    
    - filter:
        expression: "(typeof campaignMsg !== 'undefined' && campaignMsg !== null) ? true : false;"
```

{% endcode %}

### Output Event

The following fields are added to the processed StreamEvent object.

```
// Some code

```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.fractalworks.io/joule/use-case-examples/telco/geospatial-marketing.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
